<template>
  <div>
    <v-card class="mx-auto" max-width="150px">
      <v-card-title>Punkt: {{ number }}</v-card-title>
      <v-card-text>
        <v-text-field
          label="Latitude"
          :error="$v.latitude.$invalid"
          :messages="msg_latitude"
          v-model="latitude"
          @change="update($event, 'latitude')"
        ></v-text-field>

        <v-text-field
          label="Longitude"
          type="number"
          :messages="msg_longitude"
          :error="$v.longitude.$invalid"
          v-model="longitude"
          @change="update($event, 'longitude')"
        ></v-text-field>
      </v-card-text>
    </v-card>
  </div>
</template>
<script>
const mustBeIntOrFloat = value => {
  return typeof parseFloat(value) === "number" && !isNaN(parseFloat(value));
};
import { validationMixin } from "vuelidate";
import { required, maxValue, minValue } from "vuelidate/lib/validators";
export default {
  mixins: [validationMixin],
  props: ["proplongitude", "proplatitude", "propnumber"],
  computed: {
    msg_latitude() {
      let mesages = "";
      if (!this.$v.latitude.maxValue || !this.$v.latitude.minValue) {
        mesages += "Value between -90 < x <90 ; ";
      }
      if (!this.$v.latitude.mustBeIntOrFloat) {
        mesages += "Use Number ; ";
      }
      if (!this.$v.latitude.required) {
        mesages += "Value required ; ";
      }
      return mesages;
    },
    msg_longitude() {
      let mesages = "";
      if (!this.$v.longitude.maxValue || !this.$v.longitude.minValue) {
        mesages += "Value between -180 < x <180 ; ";
      }
      if (!this.$v.longitude.mustBeIntOrFloat) {
        mesages += "Use Number ; ";
      }
      if (!this.$v.longitude.required) {
        mesages += "Value required ; ";
      }
      return mesages;
    }
  },

  watch: {
    "$v.$invalid": function(isError) {
      this.$emit("error", { id: this.propnumber, isError });
    },
    proplongitude: function(newData) {
      this.longitude = newData;
    },
    proplatitude: function(newData) {
      this.latitude = newData;
    }
  },
  data: function() {
    return {
      error: true,
      longitude: this.proplongitude,
      latitude: this.proplatitude,
      number: this.propnumber
    };
  },
  validations: {
    longitude: {
      required,
      mustBeIntOrFloat,
      maxValue: maxValue(180),
      minValue: minValue(-180)
    },
    latitude: {
      required,
      mustBeIntOrFloat,
      maxValue: maxValue(90),
      minValue: minValue(-90)
    }
  },
  methods: {
    update: function(value, name) {
      if (!this.$v[name].$invalid) {
        let payload = {
          name,
          value,
          id: this.number
        };

        this.$emit("updateInput", payload);
      }
    }
  }
};
</script>
